'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _sources;

function _load_sources() {
  return _sources = require('../consumer/component/sources');
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LinkFile = function (_AbstractVinyl) {
  _inherits(LinkFile, _AbstractVinyl);

  function LinkFile() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, LinkFile);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = LinkFile.__proto__ || Object.getPrototypeOf(LinkFile)).call.apply(_ref, [this].concat(args))), _this), _this.override = false, _this.writeAutoGeneratedMessage = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(LinkFile, [{
    key: 'write',
    // needed for logging purposes

    // existing path where the link is pointing to (needed for logging purposes)
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee() {
        var fileContent, data;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(!this.override && (_fsExtra || _load_fsExtra()).default.existsSync(this.path))) {
                  _context.next = 4;
                  break;
                }

                fileContent = (_fsExtra || _load_fsExtra()).default.readFileSync(this.path).toString();

                if (fileContent.includes((_constants || _load_constants()).AUTO_GENERATED_STAMP)) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt('return', Promise.resolve(this.path));

              case 4:
                data = this.writeAutoGeneratedMessage ? (_constants || _load_constants()).AUTO_GENERATED_MSG + this.contents : this.contents;
                _context.next = 7;
                return (_fsExtra || _load_fsExtra()).default.outputFile(this.path, data);

              case 7:
                return _context.abrupt('return', Promise.resolve(this.path));

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function write() {
        return _ref2.apply(this, arguments);
      }

      return write;
    }()
  }], [{
    key: 'load',
    value: function load(_ref3) {
      var filePath = _ref3.filePath,
          base = _ref3.base,
          content = _ref3.content,
          _ref3$override = _ref3.override,
          override = _ref3$override === undefined ? false : _ref3$override,
          _ref3$writeAutoGenera = _ref3.writeAutoGeneratedMessage,
          writeAutoGeneratedMessage = _ref3$writeAutoGenera === undefined ? true : _ref3$writeAutoGenera,
          srcPath = _ref3.srcPath,
          componentId = _ref3.componentId;

      var linkFile = new LinkFile({
        base: base || (_path || _load_path()).default.dirname(filePath),
        path: filePath,
        contents: Buffer.from(content)
      });
      linkFile.override = override;
      linkFile.writeAutoGeneratedMessage = writeAutoGeneratedMessage;
      linkFile.srcPath = srcPath;
      linkFile.componentId = componentId;
      return linkFile;
    }
  }]);

  return LinkFile;
}((_sources || _load_sources()).AbstractVinyl);

exports.default = LinkFile;